## quassel 0.12.1

=== CMakeLists.txt ===
# Main CMake file for building Quassel IRC
#
# See INSTALL for possible CMake options (or read the code, Luke)
#####################################################################

# General setup
#####################################################################

project(QuasselIRC)

# Versions
set(QUASSEL_MAJOR  0)
set(QUASSEL_MINOR 12)
set(QUASSEL_PATCH  1)
set(QUASSEL_VERSION_STRING "0.12.1")

# We want to know CMake's version for debug reasons
message(STATUS "Using CMake ${CMAKE_VERSION}")

# Tell CMake about or own modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# General conveniences
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include various CMake modules...
include(CMakePushCheckState)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXSourceCompiles)
include(CMakeDependentOption)
include(FeatureSummary)

# ... and our own stuff
include(QuasselCompileSettings)
include(QuasselMacros)


# Options and variables that can be set on the command line
#####################################################################

# First, choose a Qt version. We support USE_QT4 and USE_QT5; if neither is set, prefer Qt4 for now
option(USE_QT5 "Enable support for Qt5 (disables KDE integration)" OFF)
if (USE_QT4) # takes precedence
    set(USE_QT5 OFF)
else()
    if (NOT USE_QT5)
        set(USE_QT4 ON)
    endif()
endif()

# Select the binaries to build
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the client-only binary"             ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)
add_feature_info(WANT_CORE WANT_CORE "Build the core (server) binary")
add_feature_info(WANT_QTCLIENT WANT_QTCLIENT "Build the client-only binary (requires a core to connect to)")
add_feature_info(WANT_MONO WANT_MONO "Build the monolithic (all-in-one) binary")

# Whether to enable KDE integration (work in progress for Qt5 / KDE Frameworks)
# Note that when building with Qt5, WITH_KDE enables integration with higher-tier KDE frameworks that
# require runtime support. We still optionally make use of certain Tier 1 frameworks even if WITH_KDE
# is disabled.
if (USE_QT4)
    option(WITH_KDE "KDE4 integration" OFF)
    add_feature_info(WITH_KDE WITH_KDE "Enable KDE4 integration")
else()
    option(WITH_KDE "Integration with the KDE Frameworks runtime environment")
    add_feature_info(WITH_KDE WITH_KDE "Integrate with the KDE Frameworks runtime environment")
endif()

cmake_dependent_option(WITH_OXYGEN "Install Oxygen icon set (usually shipped with KDE)" ON "NOT WITH_KDE" OFF)
if (NOT WITH_KDE)
    add_feature_info(WITH_OXYGEN WITH_OXYGEN "Install Oxygen icon set")
endif()

# For this, the feature info is added after we know if QtWebkit is installed
option(WITH_WEBKIT "WebKit support (for link previews)" ON)

if (APPLE)
    # Notification Center is only available in > 10.8, which is Darwin v12
    if (CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
        option(WITH_NOTIFICATION_CENTER "OS X Notification Center support" ON)
        add_feature_info(WITH_NOTIFICATION_CENTER WITH_NOTIFICATION_CENTER "Use the OS X Notification Center")
    endif()
endif()

# Always embed on Windows, OSX or for a static build; never embed when enabling KDE integration
set(EMBED_DEFAULT OFF)
if (STATIC OR WIN32 OR APPLE)
    set(EMBED_DEFAULT ON)
endif()
cmake_dependent_option(EMBED_DATA "Embed icons and translations into the binaries instead of installing them" ${EMBED_DEFAULT}
                                   "NOT STATIC;NOT WIN32;NOT WITH_KDE" ${EMBED_DEFAULT})
if (NOT EMBED_DEFAULT)
    add_feature_info(EMBED_DATA EMBED_DATA "Embed icons and translations in the binaries instead of installing them")
endif()

# The following options are not for end-user consumption, so don't list them in the feature summary
cmake_dependent_option(DEPLOY "Add required libs to bundle resources and create a dmg. Note: requires Qt to be built with 10.4u SDK" OFF "APPLE" OFF)

# Handle with care
set(QT_PATH "" CACHE PATH "Path to a Qt4 installation to use instead of the system Qt (e.g. for static builds)")

# Static builds are not supported and require some manual setup! Don't enable unless you know what you're doing (we don't know either)
cmake_dependent_option(STATIC      "Enable static building (not supported)" OFF "NOT WITH_KDE" OFF)

# For static builds, arbitrary extra libs might need to be linked
# Define a comma-separated list here
# e.g. for pgsql, we need -DLINK_EXTRA=pq;crypt
set(LINK_EXTRA "" CACHE STRING "Semicolon-separated list of libraries to be linked")
if (LINK_EXTRA)
    string(REPLACE "," ";" LINK_EXTRA ${LINK_EXTRA})
    link_libraries(${LINK_EXTRA})
endif()


# Setup CMake
#####################################################################

if (USE_QT5 AND WITH_KDE)
    cmake_minimum_required(VERSION 2.8.12)
else()
    cmake_minimum_required(VERSION 2.8.9)
endif()

# Setting COMPILE_DEFINITIONS_<CONFIG> is deprecated since CMake 3.0 in favor of generator expressions.
# These have existed since CMake 2.8.10; until we depend on that, we have to explicitly enable the old policy.
if (CMAKE_MAJOR_VERSION GREATER 2)
    cmake_policy(SET CMP0043 OLD)
endif()


# Simplify later checks
#####################################################################

if (WANT_MONO OR WANT_QTCLIENT)
    set(BUILD_GUI true)
endif()
if (WANT_MONO OR WANT_CORE)
    set(BUILD_CORE true)
endif()


# Set up Qt
#####################################################################

if (USE_QT5)
    message(STATUS "Building for Qt5...")
    set(QT_MIN_VERSION "5.2.0")
    add_definitions(-DHAVE_QT5)
else()
    message(STATUS "Building for Qt4...")
    set(QT_MIN_VERSION "4.8.0")

    # Select a Qt installation here, if you don't want to use system Qt
    if(QT_PATH)
        # FindQt4 will look for the qmake binary in $PATH, so we just prepend QT_PATH
        set(ENV{PATH} ${QT_PATH}/bin:$ENV{PATH})
    endif()
endif()


# Find package dependencies
#
# Note that you can forcefully disable optional packages
# using -DCMAKE_DISABLE_FIND_PACKAGE_<PkgName>=TRUE
#####################################################################

if (USE_QT5)
    find_package(Qt5Core ${QT_MIN_VERSION} QUIET)
    set_package_properties(Qt5Core PROPERTIES TYPE REQUIRED
        URL "http://qt.digia.com"
        DESCRIPTION "contains core functionality for Qt"
    )
    # find_package without REQUIRED won't check for the version properly; also, older Qt5 versions
    # used Qt5Core_VERSION_STRING... let's just make sure here that we bail out here if our Qt5 is not new enough.
    if (NOT Qt5Core_VERSION OR Qt5Core_VERSION VERSION_LESS ${QT_MIN_VERSION})
        message(FATAL_ERROR "Could NOT find Qt5 >= version ${QT_MIN_VERSION}!")
    endif()

    find_package(Qt5Network QUIET)
    set_package_properties(Qt5Network PROPERTIES TYPE REQUIRED
        DESCRIPTION "the network module for Qt5"
    )

    if (BUILD_GUI)
        find_package(Qt5Gui QUIET)
        set_package_properties(Qt5Gui PROPERTIES TYPE REQUIRED
            DESCRIPTION "the GUI module for Qt5"
        )
        find_package(Qt5Widgets QUIET)
        set_package_properties(Qt5Widgets PROPERTIES TYPE REQUIRED
            DESCRIPTION "the widgets module for Qt5"
        )

        find_package(Qt5DBus QUIET)
        set_package_properties(Qt5DBus PROPERTIES TYPE RECOMMENDED
            URL "http://qt.digia.com"
            DESCRIPTION "D-Bus support for Qt5"
            PURPOSE     "Needed for supporting D-Bus-based notifications and tray icon, used by most modern desktop environments"
        )
        if (Qt5DBus_FOUND)
            find_package(dbusmenu-qt5 QUIET CONFIG)
            set_package_properties(dbusmenu-qt5 PROPERTIES TYPE RECOMMENDED
                URL "https://launchpad.net/libdbusmenu-qt"
                DESCRIPTION "a library implementing the DBusMenu specification"
                PURPOSE     "Required for having a context menu for the D-Bus-based tray icon"
            )
        endif()

        find_package(Phonon4Qt5 QUIET)
        set_package_properties(Phonon4Qt5 PROPERTIES TYPE RECOMMENDED
            URL "https://projects.kde.org/projects/kdesupport/phonon"
            DESCRIPTION "a multimedia abstraction library"
            PURPOSE     "Required for audio notifications"
        )

        find_package(LibsnoreQt5 QUIET)
        set_package_properties(LibsnoreQt5 PROPERTIES TYPE OPTIONAL
            URL "https://github.com/TheOneRing/Snorenotify"
            DESCRIPTION "a cross-platform notification framework"
            PURPOSE     "Enable support for the snorenotify framework"
        )

        if (WITH_WEBKIT)
            find_package(Qt5WebKit QUIET)
            set_package_properties(Qt5WebKit PROPERTIES TYPE RECOMMENDED
                URL "http://qt.digia.com"
                DESCRIPTION "a WebKit implementation for Qt"
                PURPOSE     "Needed for displaying previews for URLs in chat"
            )
            if (Qt5WebKit_FOUND)
                find_package(Qt5WebKitWidgets QUIET)
                set_package_properties(Qt5WebKitWidgets PROPERTIES TYPE RECOMMENDED
                    URL "http://qt.digia.com"
                    DESCRIPTION "widgets for Qt's WebKit implementation"
                    PURPOSE     "Needed for displaying previews for URLs in chat"
                )
            endif()
        endif()
        add_feature_info("WITH_WEBKIT, QtWebKit and QtWebKitWidgets modules" Qt5WebKitWidgets_FOUND "Support showing previews for URLs in chat")

        # KDE Frameworks
        ################

        if (WITH_KDE)
            set(ecm_find_type "REQUIRED")
        else()
            # Even with KDE integration disabled, we optionally use tier1 frameworks if we find them
            set(ecm_find_type "RECOMMENDED")
        endif()

        # extra-cmake-modules
        find_package(ECM NO_MODULE QUIET)
        set_package_properties(ECM PROPERTIES TYPE ${ecm_find_type}
            URL "https://projects.kde.org/projects/kdesupport/extra-cmake-modules"
            DESCRIPTION "extra modules for CMake, maintained by the KDE project"
            PURPOSE     "Required to find KDE Frameworks components"
        )

        if (ECM_FOUND)
            list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
        endif()

        if (WITH_KDE)
            find_package(KF5 COMPONENTS ConfigWidgets CoreAddons Notifications NotifyConfig TextWidgets WidgetsAddons XmlGui QUIET)
            set_package_properties(KF5 PROPERTIES TYPE REQUIRED
                URL "http://www.kde.org"
                DESCRIPTION "KDE Frameworks"
                PURPOSE     "Required for integration into the Plasma desktop"
            )

        endif()

    endif(BUILD_GUI)

    if (BUILD_CORE)
        find_package(Qt5Script QUIET)
        set_package_properties(Qt5Script PROPERTIES TYPE REQUIRED
            DESCRIPTION "provides scripting support for Qt5"
        )
        find_package(Qt5Sql QUIET)
        set_package_properties(Qt5Sql PROPERTIES TYPE REQUIRED
            DESCRIPTION "the database support module for Qt5"
        )

        find_package(QCA2-QT5)
        set_package_properties(QCA2-QT5 PROPERTIES TYPE RECOMMENDED
            URL "https://projects.kde.org/projects/kdesupport/qca"
            DESCRIPTION "Qt Cryptographic Architecture"
            PURPOSE "Required for encryption support"
        )

    endif(BUILD_CORE)

    find_package(Qt5LinguistTools QUIET)
    set_package_properties(Qt5LinguistTools PROPERTIES TYPE RECOMMENDED
                           DESCRIPTION "contains tools for handling translation files"
                           PURPOSE "Required for having translations"
    )

    # Some Qt5 versions do not define a target for lconvert, so we need to find it ourselves
    if (Qt5LinguistTools_FOUND)
        if (NOT TARGET Qt5::lconvert AND TARGET Qt5::lrelease)
            get_target_property(_lrelease_location Qt5::lrelease LOCATION)

=== debian/changelog ===
quassel (0.12.1-0ubuntu0.1) vivid; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 23 Apr 2015 15:34:09 +0200

quassel (0.12.0-0ubuntu1) vivid; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 15 Apr 2015 23:21:46 +0200

quassel (0.12~rc1-0ubuntu2) vivid; urgency=medium

  * Install /usr/share/knotifications5/quassel.notifyrc to quassel-data.
  * Pass --fail-missing to dh_install.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 30 Mar 2015 23:03:03 +0200

quassel (0.12~rc1-0ubuntu1) vivid; urgency=medium

  * New upstream release. (LP: #1431008)

  [ Michael Marley ]
  * Add Wants and After on postgresql for systemd (LP: #1432161)
  * Add Restart=on-failure for systemd

  [ Felix Geyer ]
  * Drop kubuntu_02_enable_message_indicator.diff as there is no
    message indicator widget in Kubuntu anymore.

 -- Felix Geyer <debfx@ubuntu.com>  Wed, 18 Mar 2015 17:21:10 +0100

quassel (0.12~beta1-0ubuntu1) vivid; urgency=medium

  [ Michael Marley ]
  * New upstream kf5 based beta release
    - Drop patches debian/patches/CVE-2014-8483.patch,
      upstream_qca-qt5-cmake.patch and upstream_qca-qt5-code.patch
    - Add kf5 build-deps
    - Adjust install paths
  * Fix upstart job to avoid race conditions on restart

 -- Scott Kitterman <scott@kitterman.com>  Thu, 19 Feb 2015 07:42:04 -0500

quassel (0.11.0-0ubuntu2) vivid; urgency=medium

  * Build against Qt 5
  * Remove individual Qt packages, no separate KDE build with Qt 5 (yet)
  * Add upstream_qca-qt5-cmake.patch  upstream_qca-qt5-code.patch to
    fix build with qca

 -- Michael Marley <michael@michaelmarley.com>  Fri, 28 Nov 2014 15:31:11 +0000

quassel (0.11.0-0ubuntu1) vivid; urgency=medium

  * New upstream release.
  * Fix CVE-2014-8483: out-of-bounds read in ECB Blowfish decryption.
    - Add debian/patches/CVE-2014-8483.patch
    - LP: #1388333
  * Simplify debian/rules a bit by using debhelper compal level 9.
  * Add a systemd service file.

 -- Felix Geyer <debfx@ubuntu.com>  Sat, 01 Nov 2014 11:52:52 +0100

## quassel 0.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 # Versions
 set(QUASSEL_MAJOR  0)
 set(QUASSEL_MINOR 12)
-set(QUASSEL_PATCH  1)
-set(QUASSEL_VERSION_STRING "0.12.1")
+set(QUASSEL_PATCH  2)
+set(QUASSEL_VERSION_STRING "0.12.2")
 
 # We want to know CMake's version for debug reasons
 message(STATUS "Using CMake ${CMAKE_VERSION}")

=== src/common/CMakeLists.txt ===
# Builds the common module

set(SOURCES
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    compressor.cpp
    ctcpevent.cpp
    event.cpp
    eventmanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    peer.cpp
    peerfactory.cpp
    presetnetworks.cpp
    quassel.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    syncableobject.cpp
    transfer.cpp
    transfermanager.cpp
    util.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp

    # needed for automoc
    coreinfo.h
)

if (USE_QT5)
    list(APPEND SOURCES qt5cliparser.cpp)
else()
    list(APPEND SOURCES cliparser.cpp)
endif()

if (QCA2_FOUND OR QCA2-QT5_FOUND)
    set(SOURCES ${SOURCES} keyevent.cpp)
endif()

if (ZLIB_FOUND)
    add_definitions(-DHAVE_ZLIB)
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    set(SOURCES ${SOURCES} ../../3rdparty/miniz/miniz.c)
endif()

if (USE_QT4)
    set(SOURCES ${SOURCES} ../../3rdparty/sha512/sha512.c)
endif()

if (HAVE_SYSLOG)
    add_definitions(-DHAVE_SYSLOG)
endif()

if (APPLE)
    set(SOURCES ${SOURCES} mac_utils.cpp)
endif(APPLE)

if (WIN32)
    set(SOURCES ${SOURCES} logbacktrace_win.cpp)
else()
    if (EXECINFO_FOUND)
        add_definitions(-DHAVE_EXECINFO)
        include_directories(${EXECINFO_INCLUDES})
    endif()
    set(SOURCES ${SOURCES} logbacktrace_unix.cpp)
endif()

qt_add_resources(SOURCES ${COMMON_RCS})

add_library(mod_common STATIC ${SOURCES})
qt_use_modules(mod_common Core Network)

if (APPLE)
    target_link_libraries(mod_common "-framework CoreServices" "-framework CoreFoundation")
endif(APPLE)

target_link_libraries(mod_common ${CMAKE_DL_LIBS} ${EXECINFO_LIBRARIES} ${ZLIB_LIBRARIES})

# This is needed so translations are generated before trying to build the qrc.
# Should probably find a nicer solution with proper dependencies between the involved files, though...
add_dependencies(mod_common po)

=== src/qtui/CMakeLists.txt ===
# Builds the qtui module

set(SOURCES
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    debugbufferviewoverlay.cpp
    debugconsole.cpp
    debuglogwidget.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    passwordchangedlg.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    receivefiledlg.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    systemtray.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp
)

set(FORMS
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    debugbufferviewoverlay.ui
    debugconsole.ui
    debuglogwidget.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    passwordchangedlg.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    receivefiledlg.ui
    topicwidget.ui
)

set(LIBS )
set(QT_MODULES )

if (WITH_KDE4)
    add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
    include_directories(${KDE4_INCLUDES})
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY} ${KDE4_KNOTIFYCONFIG_LIBRARY})
endif()

if (WITH_KF5)
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS KF5::ConfigWidgets KF5::Notifications KF5::NotifyConfig KF5::WidgetsAddons KF5::XmlGui)
endif()

if (LIBSNORE_FOUND)
    add_definitions(-DHAVE_LIBSNORE)
    include_directories(${LIBSNORE_INCLUDE_DIRS})
    list(APPEND SOURCES snorenotificationbackend.cpp)
    list(APPEND FORMS   snorentificationconfigwidget.ui)
    list(APPEND LIBS ${LIBSNORE_LIBRARIES})
endif()

if (PHONON_FOUND OR Phonon4Qt5_FOUND)
    add_definitions(-DHAVE_PHONON)
    include_directories(${PHONON_INCLUDES})
    set(SOURCES ${SOURCES} phononnotificationbackend.cpp)
    set(FORMS ${FORMS}     phononnotificationconfigwidget.ui)
    list(APPEND LIBS ${PHONON_LIBS})  # PHONON_LIBRARIES only exists in config mode, it's not set by the legacy FindPhonon.cmake
endif()

if (QT_QTDBUS_FOUND OR Qt5DBus_FOUND)
    add_definitions(-DHAVE_DBUS)
    list(APPEND QT_MODULES DBus)
    if (dbusmenu-qt_FOUND OR dbusmenu-qt5_FOUND)
        add_definitions(-DHAVE_DBUSMENU)
        include_directories(${dbusmenu-qt_INCLUDE_DIRS} ${dbusmenu-qt5_INCLUDE_DIRS})
        if (dbusmenu-qt_FOUND)
            list(APPEND LIBS dbusmenu-qt)
        else()
            list(APPEND LIBS dbusmenu-qt5)
        endif()
    endif()

    list(APPEND SOURCES statusnotifieritem.cpp statusnotifieritemdbus.cpp dockmanagernotificationbackend.cpp)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt_add_dbus_adaptor  (SOURCES ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)
endif()

if (QT_QTWEBKIT_FOUND OR Qt5WebKitWidgets_FOUND)
    add_definitions(-DHAVE_WEBKIT)
    list(APPEND QT_MODULES WebKit)
    if (USE_QT5)
        list(APPEND QT_MODULES WebKitWidgets)
    endif()
endif()

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslinfodlg.cpp)
  set(FORMS ${FORMS} sslinfodlg.ui)
endif(HAVE_SSL)

if (INDICATEQT_FOUND)
    add_definitions(-DHAVE_INDICATEQT)
    include_directories(${INDICATEQT_INCLUDE_DIRS})
    list(APPEND SOURCES indicatornotificationbackend.cpp)
    list(APPEND FORMS   indicatornotificationconfigwidget.ui)
    list(APPEND LIBS ${INDICATEQT_LIBRARIES})
endif()

if (WITH_NOTIFICATION_CENTER)
    add_definitions(-DHAVE_NOTIFICATION_CENTER)
    list(APPEND SOURCES osxnotificationbackend.mm)
    list(APPEND LIBS "/System/Library/Frameworks/Foundation.framework")
endif()

foreach(FORM ${FORMS})
  set(FORMPATH ${FORMPATH} ui/${FORM})
endforeach(FORM ${FORMS})

# handle settingspages
include(settingspages/settingspages.cmake)
foreach(SP ${SETTINGSPAGES})
  set(SPSRC ${SPSRC} settingspages/${SP}settingspage.cpp)
  set(SPFRM ${SPFRM} settingspages/${SP}settingspage.ui)
endforeach(SP ${SETTINGSPAGES})
foreach(SRC ${SP_SOURCES})
  set(SPSRC ${SPSRC} settingspages/${SRC})
endforeach(SRC ${SP_SOURCES})
foreach(FRM ${SP_FORMS})
  set(SPFRM ${SPFRM} settingspages/${FRM})
endforeach(FRM ${SP_FORMS})

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
                    ${CMAKE_SOURCE_DIR}/src/qtui
                    ${CMAKE_SOURCE_DIR}/src/qtui/settingspages
                    ${CMAKE_SOURCE_DIR}/src/uisupport
)

qt_wrap_ui(UI ${FORMPATH} ${SPFRM})

if (USE_QT5)
    list(APPEND QT_MODULES Widgets)
endif()


add_library(mod_qtui STATIC ${SOURCES} ${SPSRC} ${UI})
qt_use_modules(mod_qtui Core Gui Network ${QT_MODULES})

target_link_libraries(mod_qtui mod_client mod_common mod_uisupport ${LIBS})

=== debian/changelog ===
quassel (0.12.2-0ubuntu1.16.04.2) xenial; urgency=medium

  * Cherry-pick fix introduced in Debian in revision 1:0.13.1-2 to fix
    apparmor profile (LP: #1863664)
  * Fix build failure with qt 5.5 with upstream patches.
    - debian/patches/be23c0c48e37617eebe0be0eb2ea5c6246dc8170.patch:
    - debian/patches/078477395aaec1edee90922037ebc8a36b072d90.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2020 19:07:40 +0100

quassel (0.12.2-0ubuntu1) wily; urgency=medium

  * Generate a 2048-bit cert. (LP: #1455990)

 -- Michael Marley <michael@michaelmarley.com>  Sun, 17 May 2015 18:58:08 -0400

quassel (0.12.2-0ubuntu0.1) vivid; urgency=medium

  * New upstream release
  - LP: #1448911 Execute initDbSession() on DB reconnects

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 27 Apr 2015 10:11:13 +0200

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Harald Sitter <apachelogger@ubuntu.com>
Build-Depends: debhelper (>= 9),
 dpkg-dev (>= 1.16.1~),
 dh-apparmor,
 pkg-kde-tools (>= 0.5.0),
 cmake,
 libdbus-1-dev,
 libqca-qt5-2-dev,
 libindicate-qt-dev,
 libdbusmenu-qt-dev,
 zlib1g-dev,
 qttools5-dev-tools,
 qttools5-dev,
 qtscript5-dev,
 libphonon4qt5-dev,
 libphonon4qt5experimental-dev,
 libdbusmenu-qt5-dev,
 libqt5webkit5-dev,
 dh-systemd,
 extra-cmake-modules,
 libkf5textwidgets-dev,
 libkf5coreaddons-dev,
 libkf5xmlgui-dev,
 libkf5notifications-dev,
 libkf5notifyconfig-dev,
 libkf5widgetsaddons-dev
Standards-Version: 3.9.6
Homepage: http://www.quassel-irc.org/
Vcs-Bzr: lp:~ubuntu-dev/quassel/ubuntu
Vcs-Browser: http://bazaar.launchpad.net/~ubuntu-dev/quassel/ubuntu

Package: quassel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 quassel-data (= ${source:Version}), libqt5sql5-sqlite
Recommends: breeze-icon-theme
Breaks: quassel-qt4 (<< 0.11.0-0ubuntu2)
Replaces: quassel-qt4 (<< 0.11.0-0ubuntu2)
Description: IRC client
 This is a modern, cross-platform, distributed IRC client. One
 (or multiple) client(s) can attach to and detach from a central core. It's
 much like the popular combination of screen and a text-based IRC client such
 as WeeChat, but graphical.
 .
 This package provides a complete traditional IRC client (client and core) in
 a single integrated package

Package: quassel-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 quassel-data (= ${source:Version})
Recommends: oxygen-icon-theme
Breaks: quassel-client-qt4 (<< 0.11.0-0ubuntu2)
Replaces: quassel-client-qt4 (<< 0.11.0-0ubuntu2)
Description: distributed IRC client - client component
 This is the client component of Quassel. A modern, cross-platform, distributed
 IRC client, meaning that one (or multiple) client(s) can attach to and detach
 from this central core. It's much like the popular combination of screen and
 a text-based IRC client such as WeeChat, but graphical.
 .
 This package only provides Quassel's client component. If you need to run the
 core/server component on your local machine install the package 'quassel'
 instead.

Package: quassel-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, openssl, libqt5sql5-sqlite
Conflicts: quassel
Description: distributed, KDE/Qt-based IRC client - core/server component
 This is the core component of Quassel. A modern, cross-platform, distributed
 IRC client, meaning that one (or multiple) client(s) can attach to and detach
 from this central core. It's much like the popular combination of screen and
 a text-based IRC client such as WeeChat, but graphical.
 .
 This package only provides Quassel's core/server component.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}
Breaks: quassel-qt4-data
Replaces: quassel-qt4-data
Description: distributed, KDE/Qt-based IRC client - data files
 This is a modern, cross-platform, distributed IRC client, meaning that one
 (or multiple) client(s) can attach to and detach from a central core. It's
 much like the popular combination of screen and a text-based IRC client such
 as WeeChat, but graphical.
 .
 This package contains architecture-independent data files needed to run
 Quassel.

Package: quassel-dbg
Section: debug
Architecture: any
Priority: extra
Depends: quassel (= ${binary:Version}) | quassel-client (= ${binary:Version}) | quassel-core (= ${binary:Version}),
 ${misc:Depends}
Description: distributed, KDE/Qt-based IRC client - debugging symbols
 These are the debugging symbols of Quassel. A modern, cross-platform,
 distributed IRC client, meaning that one (or multiple) client(s) can attach to
 and detach from this central core. It's much like the popular combination of
 screen and a text-based IRC client such as WeeChat, but graphical.
 .
 This package only provides Quassel's debugging symbols.

#Remove after Kubuntu 16.04
Package: quassel-qt4
Architecture: any
Depends: quassel, ${misc:Depends}
Description: Transitional package for Quassel
 This is an empty package to transition to quassel, it can
 be safely removed.

#Remove after Kubuntu 16.04
Package: quassel-client-qt4
Architecture: any
Depends: quassel-client, ${misc:Depends}
Description: Transitional package for Quassel Client
 This is an empty package to transition to quassel-client, it can
 be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

CMAKE_OPTIONS = -DWANT_MONO=ON -DEMBED_DATA=OFF -DUSE_QT5=ON

export DEB_BUILD_MAINT_OPTIONS = hardening=+pie,+bindnow

%:
	dh $@ --buildsystem=cmake --with=kde,systemd --parallel

override_dh_clean:
	dh_clean
	rm -rf debian/build-qt4 debian/tmp-qt4

override_dh_auto_configure:
	dh_auto_configure -Skde -- -DWITH_KDE=ON $(CMAKE_OPTIONS)

override_dh_auto_build:
	dh_auto_build -Skde
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quassel.pod > quassel.1
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quasselcore.pod > quasselcore.1
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quasselclient.pod > quasselclient.1

override_dh_auto_install:
	dh_auto_install -Skde

override_dh_install:
	dh_install -pquassel-qt4 -pquassel-client-qt4 -pquassel-qt4-data --sourcedir=debian/tmp-qt4
	dh_install --remaining-packages -Xusr/share/kde4/apps/quassel/icons/oxygen/scalable --fail-missing
	install -o root -g root -m 644 debian/quassel-core.ufw.profile debian/quassel-core/etc/ufw/applications.d/quasselcore
	install -o root -g root -m 644 debian/quassel-core.quasselcore.systemd debian/quassel-core/lib/systemd/system/quasselcore.service

override_dh_installinit:
	dh_apparmor -pquassel-core --profile-name=usr.bin.quasselcore
	dh_installinit -R --error-handler=exit --name=quasselcore

override_dh_strip:
	dh_strip --dbg-package=quassel-dbg

=== debian/watch ===
version=3
# call with uscan --repack to get an orig.tar.gz
http://quassel-irc.org/pub/quassel-([0-9\.]+)\.tar\.bz2 debian uupdate
